// DlgSysCfg.cpp : implementation file
//

#include "stdafx.h"
#include "testicandll.h"
#include "DlgSysCfg.h"
#include "CANETDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgSysCfg dialog


CDlgSysCfg::CDlgSysCfg(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSysCfg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgSysCfg)
	//}}AFX_DATA_INIT
}


void CDlgSysCfg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSysCfg)
	DDX_Control(pDX, IDC_COMBO_CANBAUD, m_ctlComboCANBaud);
	DDX_Control(pDX, IDC_COMBO_INDEX, m_ctlComboCardIndex);
	DDX_Control(pDX, IDC_COMBO_DEVTYPE, m_ctlComboCardType);
	DDX_Control(pDX, IDC_COMBO_CANIND, m_ctlComboCANInd);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgSysCfg, CDialog)
	//{{AFX_MSG_MAP(CDlgSysCfg)
	ON_CBN_SELCHANGE(IDC_COMBO_DEVTYPE, OnSelchangeComboDevtype)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgSysCfg message handlers
BOOL CDlgSysCfg::ExtSysSet()
{
	DWORD cardtype=m_ctlComboCardType.GetItemData(m_ctlComboCardType.GetCurSel());
	if (VCI_CANETE==cardtype || VCI_CANETTCP == cardtype)
	{
		CCANETDlg dlg(cardtype);
		if (IDOK!=dlg.DoModal())
		{
			return FALSE;
		}
	}
	return TRUE;
}

void CDlgSysCfg::OnOK() 
{
	if (!ExtSysSet())
	{
		MessageBox("ѡCANö");
		return;
	}
	m_global.m_syscfg.routecfg.iCardType=m_ctlComboCardType.GetItemData(m_ctlComboCardType.GetCurSel());
	// TODO: Add extra validation here
	m_global.m_syscfg.routecfg.iCardInd=m_ctlComboCardIndex.GetCurSel();
	m_global.m_syscfg.routecfg.iCANInd=m_ctlComboCANInd.GetCurSel();
	
// 	CString strtmp;
// 	m_ctlComboCANBaud.GetWindowText(strtmp);
// 	if(strtmp.GetLength()<6)
// 	{
// 		MessageBox("ѡ");
// 		return;
// 	}
// 	strtmp=strtmp.Mid(2,4);
// 	int itmp;
// 	sscanf(strtmp,"%x",&itmp);
// 	m_global.m_syscfg.routecfg.wCANBaud=itmp;
	GetBaud(m_global.m_syscfg.routecfg.iCardType);

	CDialog::OnOK();
}
void CDlgSysCfg::GetBaud(int type)
{
	if (VCI_PCI5010_U==type || VCI_PCI5020_U==type || VCI_USBCAN_E_U==type || VCI_USBCAN_2E_U==type)
	{
		CString strtmp;
		m_ctlComboCANBaud.GetWindowText(strtmp);
		if(strtmp.GetLength()<8/*6*/)
		{
			MessageBox("ѡ");
			return;
		}
		strtmp=strtmp.Mid(2,6/*4*/);
		int itmp;
		sscanf(strtmp,"%x",&itmp);
		//m_global.m_syscfg.routecfg.wCANBaud=itmp;
		m_global.m_syscfg.extcfg.newcan.dwCANBaud=itmp;
	}else
	{
		CString strtmp;
		m_ctlComboCANBaud.GetWindowText(strtmp);
		if(strtmp.GetLength()<6)
		{
			MessageBox("ѡ");
			return;
		}
		strtmp=strtmp.Mid(2,4);
		int itmp;
		sscanf(strtmp,"%x",&itmp);
		m_global.m_syscfg.routecfg.wCANBaud=itmp;
	}
}

void CDlgSysCfg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

BOOL CDlgSysCfg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
// 	m_ctlComboCardType.SetItemData(m_ctlComboCardType.AddString("PC104CAN"),VCI_PC104CAN);
// 	m_ctlComboCardType.SetItemData(m_ctlComboCardType.AddString("PCI9810"),VCI_PCI9810);
// 	m_ctlComboCardType.SetItemData(m_ctlComboCardType.AddString("PCI9820"),VCI_PCI9820);
// 	m_ctlComboCardType.SetItemData(m_ctlComboCardType.AddString("PCI9840"),VCI_PCI9840);
// 	m_ctlComboCardType.SetItemData(m_ctlComboCardType.AddString("USBCAN2"),VCI_USBCAN2);
// 	m_ctlComboCardType.SetItemData(m_ctlComboCardType.AddString("PCI5121"),VCI_PCI5121);
// 	m_ctlComboCardType.SetItemData(m_ctlComboCardType.AddString("PCI9820I"),VCI_PCI9820I);
// 	m_ctlComboCardType.SetItemData(m_ctlComboCardType.AddString("PCI9820I"),VCI_PCI9820I);
// 	m_ctlComboCardType.SetItemData(m_ctlComboCardType.AddString("PEC9920"),VCI_PEC9920);

	std::map<DWORD,CString>::iterator itr=g_type_nameMap.begin();
	while(itr!=g_type_nameMap.end())
	{
		m_ctlComboCardType.SetItemData(m_ctlComboCardType.AddString(itr->second),itr->first);
		itr++;
	}


	for(int kk=0;kk<m_ctlComboCardType.GetCount();kk++)
	{
		if(m_ctlComboCardType.GetItemData(kk)==(DWORD)m_global.m_syscfg.routecfg.iCardType)
		{
			m_ctlComboCardType.SetCurSel(kk);
		}
	}
	int cancount=m_global.GetCANCount(m_global.m_syscfg.routecfg.iCardType);
	CString strtmp;
	for(int i=0;i<cancount;i++)
	{
		strtmp.Format("%d",i);
		m_ctlComboCANInd.AddString(strtmp);
	}
	m_ctlComboCANInd.SetCurSel(m_global.m_syscfg.routecfg.iCANInd);
	m_ctlComboCardIndex.SetCurSel(m_global.m_syscfg.routecfg.iCardInd);

// 	CString strbaud[3]={"0x001c(500K)","0x041c(100K)","0x311c(10K)"};
// 	int valbaud[3]={0x001c,0x041c,0x311c};
// 	int sz=sizeof(valbaud)/sizeof(int);
// 	for(i=0;i<sz;i++)
// 	{
// 		m_ctlComboCANBaud.AddString(strbaud[i]);
// 		m_ctlComboCANBaud.SetItemData(i,valbaud[i]);
// 	}
// 	strtmp.Format("0x%04x",m_global.m_syscfg.routecfg.wCANBaud);
// 	int isel=m_ctlComboCANBaud.FindString(0,strtmp);
// 	if(isel==-1)
// 	{
// 		m_ctlComboCANBaud.AddString(strtmp);
// 		m_ctlComboCANBaud.SetItemData(i,m_global.m_syscfg.routecfg.wCANBaud);
// 		isel=i;
// 	}
// 	m_ctlComboCANBaud.SetCurSel(isel);
	InitBaud(m_global.m_syscfg.routecfg.iCardType);


	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
void CDlgSysCfg::InitBaud(int type)
{
	m_ctlComboCANBaud.ResetContent();
	int isel=0;
	if (VCI_PCI5010_U==type || VCI_PCI5020_U==type || VCI_USBCAN_E_U==type || VCI_USBCAN_2E_U==type)
	{
		CString strbaud[3]={"0x060007(500K)","0x160023(100K)","0x1C00E0(10K)"};
		int valbaud[3]={0x060007,0x160023,0x1C00E0};
		int sz=sizeof(valbaud)/sizeof(int);
		for(int i=0;i<sz;i++)
		{
			m_ctlComboCANBaud.AddString(strbaud[i]);
			m_ctlComboCANBaud.SetItemData(i,valbaud[i]);
		}
		CString strtmp;
		//strtmp.Format("0x%06x",m_global.m_syscfg.routecfg.wCANBaud);
		strtmp.Format("0x%06x",m_global.m_syscfg.extcfg.newcan.dwCANBaud);
		/*int*/ isel=m_ctlComboCANBaud.FindString(0,strtmp);
		if(isel==-1)
		{
			m_ctlComboCANBaud.AddString(strtmp);
			//m_ctlComboCANBaud.SetItemData(i,m_global.m_syscfg.routecfg.wCANBaud);
			m_ctlComboCANBaud.SetItemData(i,m_global.m_syscfg.extcfg.newcan.dwCANBaud);
			isel=i;
		}
	}else
	{
		CString strbaud[3]={"0x001c(500K)","0x041c(100K)","0x311c(10K)"};
		int valbaud[3]={0x001c,0x041c,0x311c};
		int sz=sizeof(valbaud)/sizeof(int);
		for(int i=0;i<sz;i++)
		{
			m_ctlComboCANBaud.AddString(strbaud[i]);
			m_ctlComboCANBaud.SetItemData(i,valbaud[i]);
		}
		CString strtmp;
		strtmp.Format("0x%04x",m_global.m_syscfg.routecfg.wCANBaud);
		/*int*/ isel=m_ctlComboCANBaud.FindString(0,strtmp);
		if(isel==-1)
		{
			m_ctlComboCANBaud.AddString(strtmp);
			m_ctlComboCANBaud.SetItemData(i,m_global.m_syscfg.routecfg.wCANBaud);
			isel=i;
		}
	}
	m_ctlComboCANBaud.SetCurSel(isel);
}


void CDlgSysCfg::OnSelchangeComboDevtype() 
{
	// TODO: Add your control notification handler code here
	DWORD cardtype=m_ctlComboCardType.GetItemData(m_ctlComboCardType.GetCurSel());
//	m_global.m_syscfg.routecfg.iCardType=m_ctlComboCardType.GetItemData(m_ctlComboCardType.GetCurSel());
//	int cancount=m_global.GetCANCount(m_global.m_syscfg.routecfg.iCardType);
	int cancount=m_global.GetCANCount(cardtype);
	CString strtmp;
	m_ctlComboCANInd.ResetContent();
	for(int i=0;i<cancount;i++)
	{
		strtmp.Format("%d",i);
		m_ctlComboCANInd.AddString(strtmp);
	}
// 	if(m_global.m_syscfg.routecfg.iCANInd>=cancount)
// 	{
// 		m_global.m_syscfg.routecfg.iCANInd=0;
// 	}
// 	m_ctlComboCANInd.SetCurSel(m_global.m_syscfg.routecfg.iCANInd);
	int canind=m_global.m_syscfg.routecfg.iCANInd;
	if (canind>cancount)
	{
		canind=0;
	}

	m_ctlComboCANInd.SetCurSel(canind);

	InitBaud(cardtype);
}
