using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

using icandll;


namespace testiCandll
{
    using ROUTECFG = _tagRouteCfg;
    using NEWCFG = _tagnewcfg;
    class CTestGlobal
    {
        /// <summary>
        /// ˳ʱж
        /// </summary>
        public void Uninit() 
        {
            SaveSysCfg();
        }
        /// <summary>
        /// ʼȡļ
        /// </summary>
        public void Init()
        {
            InitSysCfg();//ʼ _tagSysCfg
            
            //InitDic();//ʼֵ
            //InitDicBaud();//ʼֵ

            //
            string path = System.Windows.Forms.Application.StartupPath;
            path += "\\set.xml";
            XmlDocument xmlDoc = new XmlDocument();
            xmlDoc.Load(path);
            XmlNode root = xmlDoc.SelectSingleNode("can");
            XmlNode device = root.SelectSingleNode("device");
            InitDic(device);//
            XmlNode baud = root.SelectSingleNode("baud");
            InitDicBaud(baud);//
            XmlNode newbaud = root.SelectSingleNode("newbaud");
            InitDicnewBaud(newbaud);


	        ROUTECFG cfg = m_syscfg.routecfg;
	        uint ret = CanDLL.Mgr_AddRoute(ref cfg,ref /*&*/m_hRoute);//һICAN

        }

        

	    public struct _tagSysCfg
	    {
		    public ROUTECFG routecfg;
            public NEWCFG newcfg;
	    };
        public _tagSysCfg m_syscfg;
        public void InitSysCfg()
        {
            string path = System.Windows.Forms.Application.StartupPath;
            path += "\\config.xml";
            XmlDocument xmlDoc = new XmlDocument();
            xmlDoc.Load(path);
            XmlElement cfg = (XmlElement)xmlDoc.SelectSingleNode("config");            
            m_syscfg.routecfg.iCardType = Convert.ToInt32(cfg.GetAttribute("iCardType"));
            m_syscfg.routecfg.iCardInd = Convert.ToInt32(cfg.GetAttribute("iCardInd"));
            m_syscfg.routecfg.iCANInd = Convert.ToInt32(cfg.GetAttribute("iCANInd"));
            m_syscfg.routecfg.wCANBaud = Convert.ToUInt16(cfg.GetAttribute("wCANBaud"),16);//ļжȡ 16 
            m_syscfg.routecfg.wMasterID = Convert.ToUInt16(cfg.GetAttribute("wMasterID"));
            m_syscfg.routecfg.iMasterCycle = Convert.ToInt32(cfg.GetAttribute("iMasterCycle"));
            //m_syscfg.routecfg.iCardType = CanDLL.VCI_PCI9820;
            //m_syscfg.routecfg.iCardInd = 0;
            //m_syscfg.routecfg.iCANInd = 0;
            //m_syscfg.routecfg.wCANBaud = 0x001c;
            //m_syscfg.routecfg.wMasterID = 0;
            //m_syscfg.routecfg.iMasterCycle = 500;    

            m_syscfg.newcfg.dwCANBaud = Convert.ToUInt32(cfg.GetAttribute("dwCANBaud"), 16);
            m_syscfg.newcfg.bserver = Convert.ToUInt32(cfg.GetAttribute("bserver"));
            m_syscfg.newcfg.srcport = Convert.ToUInt32(cfg.GetAttribute("srcport"));
            m_syscfg.newcfg.canetip = Convert.ToUInt32(cfg.GetAttribute("canetip"));
            m_syscfg.newcfg.desport = Convert.ToUInt32(cfg.GetAttribute("desport"));

        }
        //վ config.xml
        public void SaveSysCfg()
        {     
            string path = System.Windows.Forms.Application.StartupPath;
            path += "\\config.xml";
            XmlDocument xmlDoc = new XmlDocument();
            xmlDoc.Load(path);
            //XmlNode root = xmlDoc.SelectSingleNode("config");
            XmlElement cfg = (XmlElement)/*root*/xmlDoc.SelectSingleNode("config");
            cfg.SetAttribute("iCardType", m_syscfg.routecfg.iCardType.ToString());
            cfg.SetAttribute("iCardInd", m_syscfg.routecfg.iCardInd.ToString());
            cfg.SetAttribute("iCANInd", m_syscfg.routecfg.iCANInd.ToString());
            cfg.SetAttribute("wCANBaud", "0x"+m_syscfg.routecfg.wCANBaud.ToString("X4"));// 16 
            cfg.SetAttribute("wMasterID", m_syscfg.routecfg.wMasterID.ToString());
            cfg.SetAttribute("iMasterCycle", m_syscfg.routecfg.iMasterCycle.ToString());

            cfg.SetAttribute("dwCANBaud", "0x" + m_syscfg.newcfg.dwCANBaud.ToString("X4"));
            cfg.SetAttribute("bserver",m_syscfg.newcfg.bserver.ToString());
             cfg.SetAttribute("srcport",m_syscfg.newcfg.srcport.ToString());
             cfg.SetAttribute("canetip",m_syscfg.newcfg.canetip.ToString());
             cfg.SetAttribute("desport", m_syscfg.newcfg.desport.ToString());
            xmlDoc.Save(path);
        }
        

	    public IntPtr/*HANDLE*/ m_hRoute;//վ
        


        //ֵCAN  ͶӦ ͺ
        Dictionary<string, Int32> m_dic = new Dictionary<string, int>();
        //CAN ͺ   ÿӵеCANͨ
        Dictionary<Int32, Int32> m_dicCanCount = new Dictionary<Int32, int>();
        //ļжȡʼ
        void InitDic(XmlNode device)
        {
            XmlNodeList xnl = device.ChildNodes;
            string name;
            string type;
            string count;
            XmlElement xe;
            foreach (XmlNode xn in xnl)
            {
                xe=(XmlElement)xn;
                name = xe.GetAttribute("caption");
                type = xe.GetAttribute("type");
                count = xe.GetAttribute("cancount");
                m_dic.Add(name, Convert.ToInt32(type));
                m_dicCanCount.Add(Convert.ToInt32(type), Convert.ToInt32(count));
            }
        }
        //Ӳʼ  ûʹõú
        void InitDic()
        {
            m_dic.Add("PCI5121", CanDLL.VCI_PCI5121);
            m_dic.Add("PCI9810", CanDLL.VCI_PCI9810);
            m_dic.Add("USBCAN1", CanDLL.VCI_USBCAN1);
            m_dic.Add("USBCAN2", CanDLL.VCI_USBCAN2);
            m_dic.Add("PCI9820", CanDLL.VCI_PCI9820);
            m_dic.Add("CAN232", CanDLL.VCI_CAN232);
            m_dic.Add("PCI5110", CanDLL.VCI_PCI5110);
            m_dic.Add("CANLITE", CanDLL.VCI_CANLITE);
            m_dic.Add("ISA9620", CanDLL.VCI_ISA9620);
            m_dic.Add("ISA5420", CanDLL.VCI_ISA5420);
            m_dic.Add("PC104CAN", CanDLL.VCI_PC104CAN);
            m_dic.Add("CANETE", CanDLL.VCI_CANETE);
            m_dic.Add("DNP9810", CanDLL.VCI_DNP9810);
            m_dic.Add("PCI9840", CanDLL.VCI_PCI9840);
            m_dic.Add("PC104CAN2", CanDLL.VCI_PC104CAN2);
            m_dic.Add("PCI9820I", CanDLL.VCI_PCI9820I);
            m_dic.Add("PEC9920", CanDLL.VCI_PEC9920);

            m_dic.Add("CANETTCP", CanDLL.VCI_CANETTCP);
            m_dic.Add("PCI5010_U", CanDLL.VCI_PCI5010_U);
            m_dic.Add("USBCAN_E_U", CanDLL.VCI_USBCAN_E_U);
            m_dic.Add("USBCAN_2E_U", CanDLL.VCI_USBCAN_2E_U);
            m_dic.Add("PCI5020_U", CanDLL.VCI_PCI5020_U);


        }
        public Int32 GetType(string name) 
        {
            return m_dic[name];
        }
        //CANƵ
        public string[] Getnames()
        {        
            string [] str = new string[m_dic.Count];
            int i = 0;
            foreach (KeyValuePair<string, Int32> kvp in m_dic)
            {
                str.SetValue(kvp.Key,i++);
            }
            return str;
        }
        //CANͺŷ
        public string GetName(int type)
        {
            foreach (KeyValuePair<string, Int32> kvp in m_dic)
            {
                if (type == kvp.Value)
                {
                    return kvp.Key;
                }
            }
            return null;
        }

        //CANͺŷ CANӵе CAN·
        public int GetCANCount(int devtype)
        {
            //switch (devtype)
            //{
            //    case CanDLL.VCI_PC104CAN:
            //    case CanDLL.VCI_PCI9810:
            //        return 1;
            //        break;
            //    case CanDLL.VCI_PCI9820:
            //    case CanDLL.VCI_USBCAN2:
            //    case CanDLL.VCI_PCI5121:
            //    case CanDLL.VCI_PCI9820I:
            //    case CanDLL.VCI_PEC9920:
            //        return 2;
            //        break;
            //    case CanDLL.VCI_PCI9840:
            //        return 4;
            //        break;
            //    default:
            //        return 1;
            //}
            return m_dicCanCount[devtype];
        }
        
        //ֵ ַ Ӧ 
        Dictionary<string, UInt16> m_dicBaud = new Dictionary<string, UInt16>();
        //ļжȡʼ ֵ
        void InitDicBaud(XmlNode baud)
        {
            XmlNodeList xnl = baud.ChildNodes;
            string name;
            string value; ;
            XmlElement xe;
            foreach (XmlNode xn in xnl)
            {
                xe = (XmlElement)xn;
                name = xe.GetAttribute("caption");
                value = xe.GetAttribute("value");
                m_dicBaud.Add(name, Convert.ToUInt16(value,16));
            }
        }  
        Dictionary<string, UInt32> m_dicnewBaud = new Dictionary<string, UInt32>();
        void InitDicnewBaud(XmlNode baud)
        {
            XmlNodeList xnl = baud.ChildNodes;
            string name;
            string value; ;
            XmlElement xe;
            foreach (XmlNode xn in xnl)
            {
                xe = (XmlElement)xn;
                name = xe.GetAttribute("caption");
                value = xe.GetAttribute("value");
                m_dicnewBaud.Add(name, Convert.ToUInt32(value, 16));
            }
        }
        //Ӳʼ ûʹõú
        void InitDicBaud()
        {
            m_dicBaud.Add("0x001c(500K)",0x001c);
            m_dicBaud.Add("0x041c(100K)",0x041c);
            m_dicBaud.Add("0x311c(10K)",0x311c);
        }
        //ȡʵϿ
        public string[] GetBaudnames()
        {
            string[] str = new string[m_dicBaud.Count];
               int i = 0;
            foreach (KeyValuePair<string, UInt16> kvp in m_dicBaud)
            {
                str.SetValue(kvp.Key, i++);
            }
            return str;
        }
        //Ʒزֵ
        public UInt16 GetBaud(string str)
        {
            return m_dicBaud[str];
        }
        public UInt32 GetnewBaud(string str)
        {
            return m_dicnewBaud[str];
        }
        //ݲֵ
        public string GetBaudName(UInt16 type)
        {
            foreach (KeyValuePair<string, UInt16> kvp in m_dicBaud)
            {
                if (type == kvp.Value)
                {
                    return kvp.Key;
                }
            }
            return null;
        }

        //byteת 16  string
        public string DatatoStr(byte[] pdata, uint len)
        {
            string strtmp="";
            for (int i = 0; i < len; i++)
            {
                strtmp += pdata[i].ToString("X2") + " ";
            }
            return strtmp;
        }

        /// <summary>
        /// תֽ
        /// </summary>
        /// <param name="b"></param>
        /// <returns></returns>
        public /*static*/ UInt64 BytesToInt(byte[] b)
        {
            UInt64 mask = 0xff;
            UInt64 temp = 0;
            UInt64 res = 0;
            for (int i = 0; i < b.Length; i++)
            {
                res <<= 8;
                temp = b[i] & mask;
                res |= temp;
            }
            return res;
        }

        /// <summary>
        /// ֽת
        /// </summary>
        /// <param name="num"></param>
        /// <param name="bits">λռλ</param>
        /// <returns></returns>
        public /*static*/ byte[] IntToBytes(UInt64 num, int bits)
        {
            byte[] b = new byte[bits];
            for (int i = 0; i < bits; i++)
            {
                //b[i] = (byte)(num >> ((bits - 1) * 8 - i * 8));//ֽʹ
                b[i] = (byte)((num >> (i * 8)) & 0xff);

            }
            return b;
        }

        public UInt32 striptolong(string strip)
        {
            //string pip = textBox_IP.Text;
            //char[] chars = strip.ToCharArray();
            string[] chars = strip.Split('.');
            byte[] bs = new byte[4];
            for (int i = 0; i < chars.Length; i++)
            {
                //bs[i] = (byte)chars[i];
                bs[i] = Convert.ToByte(chars[i]);
            }
            return (UInt32)BytesToInt(bs);
        }
        public string longiptostr(UInt32 ip)
        {
            byte[] iparr = IntToBytes(ip, 4);
            //string strip;
            return iparr[3].ToString() + "." + iparr[2].ToString() + "." + iparr[1].ToString() + "." + iparr[0].ToString();

        }
    }
}
