using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace testiCandll
{
    public partial class FormSet : Form
    {
        public FormSet()
        {
            InitializeComponent();
        }

        private void FormSet_Load(object sender, EventArgs e)
        {
            comboBox_type.Items.AddRange(Program.m_global.Getnames());
            string name = Program.m_global.GetName(Program.m_global.m_syscfg.routecfg.iCardType);
            comboBox_type.SelectedIndex = comboBox_type.FindString(name);

            comboBox_devindex.SelectedIndex = Program.m_global.m_syscfg.routecfg.iCardInd;
            comboBox_canindex.SelectedIndex = Program.m_global.m_syscfg.routecfg.iCANInd;

            comboBox_baud.Items.AddRange(Program.m_global.GetBaudnames());
            name = Program.m_global.GetBaudName(Program.m_global.m_syscfg.routecfg.wCANBaud);
            comboBox_baud.SelectedIndex = comboBox_baud.FindString(name);
        }

        private void button_ok_Click(object sender, EventArgs e)
        {
            Program.m_global.m_syscfg.routecfg.iCardType = Program.m_global.GetType(comboBox_type.Text);
            Program.m_global.m_syscfg.routecfg.iCardInd = comboBox_devindex.SelectedIndex;
            Program.m_global.m_syscfg.routecfg.iCANInd = comboBox_canindex.SelectedIndex;


            Program.m_global.m_syscfg.routecfg.wCANBaud = Program.m_global.GetBaud(comboBox_baud.Text);

            Program.m_global.m_syscfg.newcfg.dwCANBaud=Program.m_global.GetnewBaud(comboBox_baud.Text);
            Program.m_global.m_syscfg.newcfg.bserver = radioButton_server.Checked ? (UInt32)1 : (UInt32)0;
            Program.m_global.m_syscfg.newcfg.srcport = Convert.ToUInt32(textBox_srcport.Text);
            Program.m_global.m_syscfg.newcfg.desport = Convert.ToUInt32(textBox_desport.Text);
            Program.m_global.m_syscfg.newcfg.canetip = Program.m_global.striptolong(textBox_canetip.Text);
        }

        private void comboBox_type_SelectedIndexChanged(object sender, EventArgs e)
        {
            Program.m_global.m_syscfg.routecfg.iCardType = Program.m_global.GetType(comboBox_type.Text);
            int cardtype = Program.m_global.m_syscfg.routecfg.iCardType;
            int cancount = Program.m_global.GetCANCount(Program.m_global.m_syscfg.routecfg.iCardType);
            comboBox_canindex.Items.Clear();
            for (int i = 0; i < cancount; i++)
            {
                comboBox_canindex.Items.Add(i);
            }
            if (0 == cancount)//ûCANͨ
            {
                button_ok.Enabled = false;//ȷ
                MessageBox.Show("ÿûCANͨ");
                return;
            }
            else
            {
                button_ok.Enabled = true;
            }
            if (Program.m_global.m_syscfg.routecfg.iCANInd >= cancount)
            {
                Program.m_global.m_syscfg.routecfg.iCANInd = 0;
            }
            comboBox_canindex.SelectedIndex = Program.m_global.m_syscfg.routecfg.iCANInd;

            if (icandll.CanDLL.VCI_CANETE == cardtype || icandll.CanDLL.VCI_CANETTCP == cardtype)
            {
                if (icandll.CanDLL.VCI_CANETE == cardtype )
                {
                    radioButton_client.Visible = false;
                    radioButton_server.Visible = false;
                }else
                {
                    radioButton_client.Visible = true;
                    radioButton_server.Visible = true;
                    radioButton_server.Checked = (0!=Program.m_global.m_syscfg.newcfg.bserver);
                    radioButton_client.Checked = !radioButton_server.Checked;
                }
                label_srcport.Visible = true;
                textBox_srcport.Visible = true;
                textBox_srcport.Text = Program.m_global.m_syscfg.newcfg.srcport.ToString();
                label_canetip.Visible = true;
                textBox_canetip.Visible = true;
                textBox_canetip.Text = Program.m_global.longiptostr( Program.m_global.m_syscfg.newcfg.canetip);
                label_desport.Visible = true;
                textBox_desport.Visible = true;
                textBox_desport.Text = Program.m_global.m_syscfg.newcfg.desport.ToString();
            }else
            {
                radioButton_client.Visible = false;
                radioButton_server.Visible = false;
                label_srcport.Visible = false;
                textBox_srcport.Visible = false;
                label_canetip.Visible = false;
                textBox_canetip.Visible = false;
                label_desport.Visible = false;
                textBox_desport.Visible = false;
            }
        }
    }
}