using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

using icandll;

namespace testiCandll
{
    using ROUTECFG = icandll._tagRouteCfg;//

    ///
    /// Զͣ ListView 
    using LISTDATA = _tagListData;
    struct _tagListData
    {
        public IntPtr/*HANDLE*/ hSlave;//վ
        public byte/*BYTE*/ bai;//¼־ 
    };
    
    public partial class FormTest : Form
    {
        /// <summary>
        /// ´ȡ༭еǰλ ǰλ 11
        /// </summary>
        /// 
        //const int EM_GETSEL = 0xB0;
        //const int EM_LINEFROMCHAR = 0xC9;
        //const int EM_LINEINDEX = 0xBB;
        //[DllImport("user32.dll", EntryPoint = "SendMessage")]
        //public static extern int SendMessage(
        //    int hwnd,
        //    int wMsg,
        //    int wParam,
        //    ref int lParam
        //);
        //private Point GetCursorPos(int TextHwnd)
        //{
        //    int i = 0, j = 0, k = 0;
        //    int lParam = 0, wParam = 0;
        //    i = SendMessage(TextHwnd, EM_GETSEL, wParam, ref lParam);
        //    j = i / 65536;
        //    int lineNo = SendMessage(TextHwnd, EM_LINEFROMCHAR, j, ref lParam) + 1;
        //    k = SendMessage(TextHwnd, EM_LINEINDEX, -1, ref lParam);
        //    int colNo = j - k + 1;
        //    Point ret = new Point(lineNo, colNo);
        //    return ret;
        //}

        //////////////////////////////////////////////////////////////////////////////

        public FormTest()
        {
            InitializeComponent();
        }
        private void FormTest_Load(object sender, EventArgs e)
        {
            InitAll();
            comboBox_serverid.SelectedIndex = 0;
            comboBox_unslaveid.SelectedIndex = 0;
            comboBox_datatype.SelectedIndex = 0;

            button_connect.Enabled = false;//Ӳ
            button_send.Enabled = false;//Ͳ
        }
        private void FormTest_FormClosed(object sender, FormClosedEventArgs e)
        {
            CanDLL.Mgr_StopSys();//ر
        }

        //ϵͳ
        private void button_set_Click(object sender, EventArgs e)
        {
            FormSet dlg = new FormSet();
            dlg.ShowDialog();
        }

        //
        private void button_start_Click(object sender, EventArgs e)
        {
            if (CanDLL.Mgr_IsStarted() != 0)//Ϊ 1 û Ϊ 0 
            {
                timer_refreshdata.Enabled = false;//رնʱ
                CanDLL.Mgr_StopSys();
                InitAll();
            }
            else
            {
                int oldmasterid, newmasterid, icycle;
                newmasterid = comboBox_serverid.SelectedIndex;
                Program.m_global.m_syscfg.routecfg.wMasterID = Convert.ToUInt16(newmasterid);
                icycle =  Convert.ToInt32(textBox_cycle.Text);
                Program.m_global.m_syscfg.routecfg.iMasterCycle = icycle;

                ROUTECFG cfg = new ROUTECFG();
                uint ret = CanDLL.Route_GetConfig(Program.m_global.m_hRoute, ref cfg);
                oldmasterid = cfg.wMasterID;
                cfg.iCardType = Program.m_global.m_syscfg.routecfg.iCardType;
                cfg.iCardInd = Program.m_global.m_syscfg.routecfg.iCardInd;
                cfg.iCANInd = Program.m_global.m_syscfg.routecfg.iCANInd;
                cfg.wCANBaud = Program.m_global.m_syscfg.routecfg.wCANBaud;
                cfg.iMasterCycle = icycle / CanDLL.MASTER_CYCLEUNIT;
                cfg.wMasterID = Convert.ToUInt16(newmasterid);
                ret = CanDLL.Route_SetConfig(Program.m_global.m_hRoute, ref cfg);

                //豸ͺΪCANETʱҪ²
                //if (cfg.iCardType == CanDLL.VCI_CANETE)
                //{

                //    UInt32 srcport = 4001;//ض˿ڣɸʵ޸ģּΪ4001
                //    byte[] SrcPort = new byte[4];
                //    SrcPort = System.BitConverter.GetBytes(srcport);//int ת byte
                //    UInt32 canetport = 4001;//CANET˿ڣɸʵ޸ģּΪ4001
                //    byte[] CanetPort = new byte[4];
                //    CanetPort = System.BitConverter.GetBytes(canetport);
                //    byte[] CanetIP = new byte[4] { 178, 0, 168, 192 };//CANETIPַɸʵ޸ģּΪ192.168.0.178

                //    CanDLL.Route_IOCtl(Program.m_global.m_hRoute, CanDLL.IOCTL_ROUTE_SETSRCPORT, /* (BYTE*)&*/SrcPort, 4, null, 0);
                //    CanDLL.Route_IOCtl(Program.m_global.m_hRoute, CanDLL.IOCTL_ROUTE_SETDESIP, /*(BYTE*)*/CanetIP, 4, null, 0);
                //    CanDLL.Route_IOCtl(Program.m_global.m_hRoute, CanDLL.IOCTL_ROUTE_SETDESPORT, /*(BYTE*)&*/CanetPort, 4, null, 0);
                //}
                PreStart();


                Program.m_global.m_syscfg.routecfg.wMasterID = Convert.ToUInt16(newmasterid);
                Program.m_global.m_syscfg.routecfg.iMasterCycle = Convert.ToInt32(icycle);

                if ((ret= CanDLL.Mgr_StartSys()) != CanDLL.ICANOK)
                {
                    MessageBox.Show("ʧ");
                    goto exit_end;
                }

                timer_refreshdata.Interval = Program.m_global.m_syscfg.routecfg.iMasterCycle;
                timer_refreshdata.Enabled = true;//ʱ

            }
exit_end:
            if (CanDLL.Mgr_IsStarted() != 0)//ѾС
            { 
                button_start.Text = "ֹͣ";
                comboBox_serverid.Enabled = false;//վID
                button_connect.Enabled = true;//Ӱť
                button_send.Enabled = true;//Ͱť
                button_set.Enabled = false;//ϵͳò
            }
            else
            {
                button_start.Text = "";
                comboBox_serverid.Enabled = true;
                button_connect.Enabled = false;
                button_send.Enabled = false;
                button_set.Enabled = true;
            }
        }
        private void PreStart()
        {
            int cardtype = Program.m_global.m_syscfg.routecfg.iCardType;
            switch (cardtype)
            {
                case CanDLL.VCI_PCI5010_U:
                case CanDLL.VCI_PCI5020_U:
                case CanDLL.VCI_USBCAN_E_U:
                case CanDLL.VCI_USBCAN_2E_U:
                {
                    byte[] newbaud = Program.m_global.IntToBytes(Program.m_global.m_syscfg.newcfg.dwCANBaud, 4);
                    CanDLL.Route_IOCtl(Program.m_global.m_hRoute, CanDLL.IOCTL_ROUTE_SETBAUD, newbaud, 4, null, 0);
                }break;
                case CanDLL.VCI_CANETE:
                {
                    byte[] SrcPort = Program.m_global.IntToBytes(Program.m_global.m_syscfg.newcfg.srcport, 4);
                    byte[] CanetIP = Program.m_global.IntToBytes(Program.m_global.m_syscfg.newcfg.canetip, 4);
                    byte[] CanetPort = Program.m_global.IntToBytes(Program.m_global.m_syscfg.newcfg.desport, 4);
                    CanDLL.Route_IOCtl(Program.m_global.m_hRoute, CanDLL.IOCTL_ROUTE_SETSRCPORT, /* (BYTE*)&*/SrcPort, 4, null, 0);
                    CanDLL.Route_IOCtl(Program.m_global.m_hRoute, CanDLL.IOCTL_ROUTE_SETDESIP, /*(BYTE*)*/CanetIP, 4, null, 0);
                    CanDLL.Route_IOCtl(Program.m_global.m_hRoute, CanDLL.IOCTL_ROUTE_SETDESPORT, /*(BYTE*)&*/CanetPort, 4, null, 0);
                } break;
            case CanDLL.VCI_CANETTCP:
                {
                    byte[] SrcPort = Program.m_global.IntToBytes(Program.m_global.m_syscfg.newcfg.srcport, 4);
                    byte[] CanetIP = Program.m_global.IntToBytes(Program.m_global.m_syscfg.newcfg.canetip, 4);
                    byte[] CanetPort = Program.m_global.IntToBytes(Program.m_global.m_syscfg.newcfg.desport, 4);
                    byte[] bserver = Program.m_global.IntToBytes(Program.m_global.m_syscfg.newcfg.bserver, 4);
                    CanDLL.Route_IOCtl(Program.m_global.m_hRoute, CanDLL.IOCTL_ROUTE_SETSRCPORT, /* (BYTE*)&*/SrcPort, 4, null, 0);
                    CanDLL.Route_IOCtl(Program.m_global.m_hRoute, CanDLL.IOCTL_ROUTE_SETDESIP, /*(BYTE*)*/CanetIP, 4, null, 0);
                    CanDLL.Route_IOCtl(Program.m_global.m_hRoute, CanDLL.IOCTL_ROUTE_SETDESPORT, /*(BYTE*)&*/CanetPort, 4, null, 0);
                    CanDLL.Route_IOCtl(Program.m_global.m_hRoute, CanDLL.IOCTL_ROUTE_SETMODE, /*(BYTE*)&*/bserver, 4, null, 0);
                } break;
            }
        }
        private void InitAll()
        {
            listView_info.Items.Clear();//Ϣб
            comboBox_slaveid.Items.Clear();//ӵַ
            comboBox_unslaveid.Items.Clear();//δӴվ
            string[] li = new string[255];
            for (int i = 1; i <= 255; i++) { li[i-1] = i.ToString(); };
            comboBox_unslaveid.Items.AddRange(li);//δӴվϿӵַ
            comboBox_unslaveid.SelectedIndex = 0;

        }
        private void AddItemToCombo(ComboBox box, uint id)
        {
            string sid = id.ToString();
            if (!box.Items.Contains(sid))//û
            {
                box.Items.Add(sid);//
            }           
        }

        //
        private void button_connect_Click(object sender, EventArgs e)
        {
            string sIndex = comboBox_unslaveid.Text;
            uint slaveid = Convert.ToUInt32(sIndex);

            IntPtr hSlave = new IntPtr();
            uint ret = CanDLL.Route_AddSlave(Program.m_global.m_hRoute, slaveid, ref hSlave);//Ӵվ
            if (ret == CanDLL.ICANOK || ret == CanDLL.ICANERR_ITEMEXIST)
            {
                CanDLL.Route_GetSlavebyID(Program.m_global.m_hRoute, slaveid, ref hSlave);
                if (CanDLL.Slave_Connect(hSlave) == CanDLL.ICANOK)//Ӵվ
                {
                    DelItemFromCombo(comboBox_unslaveid, slaveid);
                    AddConnectedItem(hSlave);
                    comboBox_slaveid.SelectedIndex = 0;
                    comboBox_unslaveid.SelectedIndex = 0;
                }
                else
                {
                    MessageBox.Show("Ӵվʧ");
                }
            }
            else
            {
                MessageBox.Show("Ӵվʧ");
            }
        }
        //ѾӺõĴվ
        private void AddConnectedItem(IntPtr hSlave)
        {
            AddItemToCombo(comboBox_slaveid, CanDLL.Slave_GetID(hSlave));
            AddItemToList(hSlave);
        }
        //бͼ
        private void AddItemToList(IntPtr hSlave)
        {
            LISTDATA pdata2 = new LISTDATA();
            pdata2.hSlave = hSlave;
            pdata2.bai = 2;//豸Ϣ
           
            string strID = CanDLL.Slave_GetID(hSlave).ToString();
            ListViewItem lvi = listView_info.Items.Add(strID);
            lvi.SubItems.Add("豸Ϣ");
            lvi.SubItems.Add("00:00:00");

            UInt32[] iolen = new UInt32[4];
            CanDLL.Slave_GetIODataLen(hSlave,ref iolen[0],ref iolen[1],ref iolen[2],ref iolen[3]);
            string str1 = string.Format("DI={0} DO={1} AI={2} AO={3}\n",iolen[0],iolen[1],iolen[2],iolen[3]);
            lvi.SubItems.Add(str1);
            lvi.Tag = pdata2;

            LISTDATA pdata0 = new LISTDATA();
            pdata0.hSlave = hSlave;
            pdata0.bai = 0;//DI

            lvi = listView_info.Items.Add(strID);
            lvi.SubItems.Add("DI");
            lvi.SubItems.Add("00:00:00");
            lvi.SubItems.Add("");
            lvi.Tag = pdata0;

            LISTDATA pdata1 = new LISTDATA();
            pdata1.hSlave = hSlave;
            pdata1.bai = 1;//AI

            lvi = listView_info.Items.Add(strID);
            lvi.SubItems.Add("AI");
            lvi.SubItems.Add("00:00:00");
            lvi.SubItems.Add("");
            lvi.Tag = pdata1;

        }

        //ʱ
        private void timer_refreshdata_Tick(object sender, EventArgs e)
        {
            LISTDATA pdata;
            int sz = listView_info.Items.Count;
            uint len = 32;
            byte[] buff = new byte[32];
            string strtm = /*DateTime.Now.ToLongTimeString(); */DateTime.Now.ToString("HH:mm:ss.fff");
            string strtmp;

            //for (int i = 0; i < sz; i++)
            foreach (ListViewItem lvi in listView_info.Items)
            {
                //ListViewItem lvi = listView_info.Items[i];
                pdata = (LISTDATA)lvi.Tag;
                len = 32;
                
                if (pdata.bai == 1)//AI
                {
                    CanDLL.Slave_GetAIData(pdata.hSlave,buff,ref len);	
                    if(len>0)
				    {
                        //listView_info.BeginUpdate();
                        lvi.SubItems[2].Text = strtm;
                        strtmp = Program.m_global.DatatoStr(buff, len);
                        lvi.SubItems[3].Text = strtmp;
                        //listView_info.EndUpdate();
                    }
                }
                else if (pdata.bai == 0)//DI
                {
                    CanDLL.Slave_GetDIData(pdata.hSlave, buff, ref len);
                    if (len > 0)
                    {
                        //listView_info.BeginUpdate();
                        lvi.SubItems[2].Text = strtm;
                        strtmp = Program.m_global.DatatoStr(buff, len);
                        lvi.SubItems[3].Text = strtmp;
                        //listView_info.EndUpdate();
                    }
                }
                else
                {
                    if (CanDLL.Slave_IsConnected(pdata.hSlave)==0)
                    {
                        DisconnectItem(pdata.hSlave);
                        return;
                    }
                }
            }
        }
        //ͨվ  Ͽվ
        private void DisconnectItem(IntPtr hSlave)
        {
            CanDLL.Slave_Disconnect(hSlave);//Ͽ
            uint slaveid = CanDLL.Slave_GetID(hSlave);//ȡվID
            uint ret = CanDLL.Route_DelSlave(Program.m_global.m_hRoute, hSlave);//ɾվ
            DelItemFromCombo(comboBox_slaveid, slaveid);//ɾ ID
            AddItemToCombo(comboBox_unslaveid, slaveid);//δ ID
            int sz = listView_info.Items.Count;
            LISTDATA ptmpdata;
            ListViewItem lvi;
            for (int j = sz - 1; j >= 0; j--)
            {
                lvi = listView_info.Items[j];
                ptmpdata = (LISTDATA)lvi.Tag;
                if (ptmpdata.hSlave == hSlave)
                {
                    listView_info.Items.Remove(lvi);
                }
            }
        }
        private void DelItemFromCombo(ComboBox combo, uint ind)
        {
            string str1 = ind.ToString();
            if (combo.Items.Contains(str1))
            {
                combo.Items.Remove(str1);
            }            
        }

        //
        private void button_send_Click(object sender, EventArgs e)
        {
            int ind = comboBox_slaveid.SelectedIndex;
            if (ind == -1)
            {
                MessageBox.Show(this, "ѡվ");
                return;
            }
            string sid = comboBox_slaveid.Text;
            uint id = Convert.ToUInt32(sid);
            IntPtr hSlave = new IntPtr();
            CanDLL.Route_GetSlavebyID(Program.m_global.m_hRoute, id, ref hSlave);//ݴվIDȡվ	

            byte[] addrarr = {0x20,0x60};// AO DO 
            byte[] buf = new byte[32];
            uint len = 32;
            //GetByteArr(buf,ref len);//ӱ༭лȡҪ͵
	        if(GetByteArr(buf,ref len)==0)
	        {
                MessageBox.Show(this, "ȷ뷢");
		        return;
	        }
            if (CanDLL.Slave_SendData(hSlave, addrarr[comboBox_datatype.SelectedIndex], buf, len) !=CanDLL.ICANOK)
            {
                MessageBox.Show(this, "ʧ");
            }
        }
        //ӱ༭лȡݱ浽 byte 
        private int GetByteArr(byte[] pbyte, ref uint len)
        {
            string str = textBox_data.Text;
            str = str.Trim();
            if (str == "")
            {
                textBox_data.Focus();
                //MessageBox.Show("뷢");
                return 0;
            }
           
            string[] chars = str.Split(new char[] { ' ',',' });
            len = (uint)chars.Length;
            //ַΪ16ֽ
            for (int i = 0; i < chars.Length; i++)
            {
                try
                { pbyte[i] = Convert.ToByte(chars[i], 16); }
                catch 
                {
                    //MessageBox.Show("ݴ"); 
                    return 0;
                }
                
            }
	        return 1;
        }

        //бͼĲ˵
        private void toolStripMenuItem_discon_Click(object sender, EventArgs e)
        {
            if (listView_info.SelectedItems.Count <= 0)
            {
                MessageBox.Show(this,"ѡĳһ"); return;
            }
            List<IntPtr> hslavelist = new List<IntPtr>();
            LISTDATA ld;
            foreach (ListViewItem lvi in listView_info.SelectedItems)
            {
                ld = (LISTDATA)lvi.Tag;
                if (hslavelist.Contains(ld.hSlave))
                { continue; }
                else
                { hslavelist.Add(ld.hSlave); DisconnectItem(ld.hSlave);}
            }
        }
        static System.Text.RegularExpressions.Regex  rg = new   System.Text.RegularExpressions.Regex("[^0-9,a-f,A-F,\x20]+");// \x20 ոַ  в0-9a-fA-F\x20ַ
        private void textBox_data_TextChanged(object sender, EventArgs e)
        {           
            this.textBox_data.Text = rg.Replace(this.textBox_data.Text, "");//ʹ "" ֵ滻 ƥַ
        }

    }

   
}