unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,icandll, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    ComboBox_Devtype: TComboBox;
    Label2: TLabel;
    ComboBox_DevInd: TComboBox;
    Label3: TLabel;
    ComboBox_CANInd: TComboBox;
    Label4: TLabel;
    ComboBox_Baud: TComboBox;
    Label5: TLabel;
    ComboBox_MasterID: TComboBox;
    Label6: TLabel;
    Edit_MasterCycle: TEdit;
    Label7: TLabel;
    Button_Start: TButton;
    GroupBox2: TGroupBox;
    Label8: TLabel;
    ComboBox_Disslave: TComboBox;
    Button_Connect: TButton;
    GroupBox3: TGroupBox;
    Label9: TLabel;
    ComboBox_ConSlave: TComboBox;
    Label10: TLabel;
    ComboBox_Datatype: TComboBox;
    Button_SendData: TButton;
    Button_Disconnect: TButton;
    Label11: TLabel;
    Edit_Data: TEdit;
    Timer1: TTimer;
    ListView_Data: TListView;
    RadioButton_client: TRadioButton;
    RadioButton_server: TRadioButton;
    Label_srcport: TLabel;
    Edit_srcport: TEdit;
    Label_canetip: TLabel;
    Edit_canetip: TEdit;
    Label_desport: TLabel;
    Edit_desport: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Button_StartClick(Sender: TObject);
    procedure Button_ConnectClick(Sender: TObject);
    procedure Button_SendDataClick(Sender: TObject);
    procedure Button_DisconnectClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure OnDestory(Sender: TObject);
    procedure ComboBox_DevtypeChange(Sender: TObject);
  private
    { Private declarations }
  public
    m_cfg : ROUTECFG;
    m_hRoute : DWORD;
    m_baud: array[0..2] of WORD;

    m_newcfg:NEWCFG;
    m_newbaud:array[0..2] of DWORD;
  published
    procedure Selcanbaud();
    procedure SetBtnStatus();
    procedure DelAllFromList(Sender: TObject);
    procedure SetMaster(oldmaster:Integer;newmaster:Integer;Sender: TObject);
    procedure AddConnectedItem(hslave:Integer);
    procedure AddItemToCombo(box:TComboBox;slaveid:Integer);
    procedure DelItemFromCombo(box:TCombobox;slaveid:Integer);
    procedure AddItemToList(hslave:Integer);
    procedure GetByteArr(box:TEdit;buf:PBYTE;len:PInteger);
    procedure DisconnectItem(ind:Integer);
    function DataToStr(buf:array of byte;len:Integer):AnsiString;
    procedure showcanet(cardtype:Integer );
    procedure PreStart();
    procedure GetNewcfg();
  end;

var
  Form1: TForm1;



implementation

{$R *.dfm}
 function striptolong(strip:AnsiString):DWORD;
var
s1:TStringList;
ip:DWORD;
 BEGIN
      s1:=TStringList.Create();
      s1.Delimiter:='.';
      s1.DelimitedText :=strip;
      ip := StrToInt(s1.Strings[0] )*16777216 + StrToInt(s1.Strings[1] )*65536 +
            StrToInt(s1.Strings[2] )*256 + StrToInt(s1.Strings[3] );
      striptolong:=ip;
 END;
 function longiptostr(ip:DWORD):  AnsiString;
 VAR
 tmp:array[0..3] of byte ;
 BEGIN

 END;
procedure TForm1.GetNewcfg();
begin
      m_newcfg.dwCANBaud:=m_newbaud[ ComboBox_Baud.ItemIndex];
      m_newcfg.srcport :=   StrToInt(Edit_srcport.Text);
     m_newcfg.canetip := striptolong(  Edit_canetip.Text   );
     //m_newcfg.canetip := striptolong(  '192.168.21.65');
     m_newcfg.desport := StrToInt(Edit_desport.Text);
     if     RadioButton_server.Checked  then
      m_newcfg.bserver :=   1
     else
      m_newcfg.bserver :=   0;
end;
procedure TForm1.showcanet(cardtype:Integer ) ;
var
bshow:Boolean;
begin
    If (m_cfg.iCardType=VCI_CANETE) Or (m_cfg.iCardType=VCI_CANETTCP) Then
    begin
        bshow:=true;
        Label_srcport.Visible:=bshow;
        Edit_srcport.Visible:=bshow;
        Edit_srcport.Text := IntToStr(m_newcfg.srcport);
        Label_canetip.Visible:=bshow;
        Edit_canetip.Visible:=bshow;
        //Edit_canetip.Text:=longiptostr(m_newcfg.canetip);
        Label_desport.Visible:=bshow;
        Edit_desport.Visible:=bshow;
        Edit_desport.Text := IntToStr(m_newcfg.desport);
        if    VCI_CANETE=    m_cfg.iCardType then
        begin
              RadioButton_client.Visible:=not bshow;
              RadioButton_server.Visible:=not bshow;
        end
         else
        begin
            RadioButton_client.Visible:=bshow;
            RadioButton_server.Visible:=bshow;
            RadioButton_client.Checked := (m_newcfg.bserver=0);
            RadioButton_server.Checked := not RadioButton_client.Checked;
        end  ;
    end
    else
    begin
        bshow:=false;
        Label_srcport.Visible:=bshow;
        Edit_srcport.Visible:=bshow;
        Label_canetip.Visible:=bshow;
        Edit_canetip.Visible:=bshow;
        Label_desport.Visible:=bshow;
        Edit_desport.Visible:=bshow;
        RadioButton_client.Visible:=bshow;
        RadioButton_server.Visible:=bshow;
    end ;
end;

function TForm1.DataToStr(buf:array of byte;len:Integer):AnsiString;
var
str:AnsiString;
i:Integer;
begin

    For i := 0 To len - 1 do
    begin
      str := str + IntToHex(buf[i],2) + ' ';
    end;

    DataToStr := str;

end;

procedure TForm1.Selcanbaud();
var
i:Integer;
begin
  If (m_cfg.iCardType=VCI_PCI5010_U) Or (m_cfg.iCardType=VCI_USBCAN_E_U)  Or
    (m_cfg.iCardType=VCI_USBCAN_2E_U) Or (m_cfg.iCardType=VCI_PCI5020_U)
  Then
    begin
    For i := 0 To 2 do
    begin
        If m_newbaud[i] = m_newcfg.dwCANBaud Then
        begin
            ComboBox_Baud.ItemIndex:=i;
            Break;
        end;
    end;
    END
    ELSE
    begin
            For i := 0 To 2 do
      begin
        If m_baud[i] = m_cfg.wCANBaud Then
        begin
            ComboBox_Baud.ItemIndex:=i;
            Break;
        end;
    end;
    end;
end;

procedure TForm1.DelAllFromList(Sender: TObject);
var
wMasterID:WORD;
i:Integer;
begin

    ListView_Data.Clear();

    ComboBox_DisSlave.Clear();
    ComboBox_ConSlave.Clear();
    wMasterID := m_cfg.wMasterID;
    For i := 0 To wMasterID - 1 do
        ComboBox_DisSlave.Items.Add(IntToStr(i));
    For i := wMasterID + 1 To $FF - 1 do
        ComboBox_DisSlave.Items.Add(IntToStr(i));
    ComboBox_DisSlave.ItemIndex := 0;
end;

procedure TForm1.SetBtnStatus();
begin
    Button_Connect.Enabled := (Mgr_IsStarted()=1);
    Button_Disconnect.Enabled := (Mgr_IsStarted()=1);
    Button_SendData.Enabled := (Mgr_IsStarted()=1);
end;

procedure TForm1.AddConnectedItem(hslave:Integer);
begin
    AddItemToCombo(ComboBox_ConSlave, Slave_GetID(hslave));
    AddItemToList (hslave);
end;

procedure TForm1.AddItemToCombo(box:TComboBox;slaveid:Integer);
var
sz:Integer;
i:Integer;
begin
    sz := box.Items.Count;

    for i := 0 To sz - 1 do
    begin
        If StrToInt(box.Items.Strings[i]) > slaveid Then
        begin
            box.Items.Insert(i,IntToStr(slaveid));
            Exit;
        end
        Else If StrToInt(box.Items.Strings[i]) = slaveid Then
            Exit;
    end;

    box.Items.Insert(sz,IntToStr(slaveid));
end;

procedure TForm1.DelItemFromCombo(box:TCombobox;slaveid:Integer);
var
str1:AnsiString;
icount:Integer;
i:Integer;
begin
    str1 := inttostr(slaveid);
    icount := box.Items.Count;
    For i := 0 To icount - 1 do
    begin
        If box.Items.Strings[i] = str1 Then
            box.Items.Delete(i);
    end;

    If (box.ItemIndex = -1) And (box.Items.count > 0) Then
        box.ItemIndex := 0;

end;

procedure TForm1.AddItemToList(hslave:Integer);
var
str1:AnsiString;
itemx:TListItem;
iolen:array[0..3] of Integer;
begin
    str1 := IntToStr(Slave_GetID(hslave));
    itemx:=ListView_Data.Items.Add;
    itemx.Caption:=str1;
    itemx.Data:=Pointer(hslave);
    itemx.SubItems.Add('豸Ϣ');
    itemx.SubItems.Add('00:00:00');

    Slave_GetIODataLen(hslave, @iolen[0], @iolen[1], @iolen[2], @iolen[3]);
    str1 := 'DI=' + IntToStr(iolen[0]) + ' DO=' + IntToStr(iolen[1]) + ' AI=' + IntToStr(iolen[2]) + ' AO=' + IntToStr(iolen[3]);
    itemx.SubItems.Add(str1);

    str1 := IntToStr(Slave_GetID(hslave));
    itemx:=ListView_Data.Items.Add;
    itemx.Data:=Pointer(hslave);
    itemx.Caption:=str1;
    itemx.SubItems.Add('DI');
    itemx.SubItems.Add('00:00:00');
    itemx.SubItems.Add(' ');

    str1 := IntToStr(Slave_GetID(hslave));
    itemx:=ListView_Data.Items.Add;
    itemx.Data:=Pointer(hslave);
    itemx.Caption:=str1;
    itemx.SubItems.Add('AI');
    itemx.SubItems.Add('00:00:00');
    itemx.SubItems.Add(' ');

end;
procedure TForm1.DisconnectItem(ind:Integer);
var
hslave2,hslave:Integer;
j,sz:integer;
begin
    hslave := Integer(ListView_Data.Items[ind].Data);
    Slave_Disconnect (hslave);
    DelItemFromCombo(ComboBox_ConSlave, Slave_GetID(hslave));
    AddItemToCombo(ComboBox_DisSlave, Slave_GetID(hslave));
    sz := ListView_Data.Items.Count;
    For j := sz-1 downto 0 do
    begin 
        hslave2 := Integer(ListView_Data.Items[j].Data);
        If hslave2 = hslave Then
            ListView_Data.Items.Delete(j);
    end;
end;

procedure TForm1.GetByteArr(box:TEdit;buf:PBYTE;len:PInteger);
var
textbuf:AnsiString;
strdata:AnsiString;
ptmp:PBYTE;
i:Integer;
begin
    textbuf:=box.Text;
    If Length(textbuf) > (len^ * 3) Then
        Exit;
    len^ := Length(textbuf) div 3;
    If len^ = 0 Then
        Exit;

  ptmp:=buf;

  for i:=0 to len^-1 do
    begin
      strdata:=Copy(textbuf,3*i+1,2);
      strdata:=Trim(strdata);
      ptmp^:=StrToInt('0x'+strdata);
      Inc(ptmp);
    end;
  
end;

procedure TForm1.SetMaster(oldmaster:Integer;newmaster:Integer;Sender: TObject);
var
i:Integer;
ifind:Integer;
begin
    ifind:=ComboBox_DisSlave.Items.IndexOf(IntToStr(newmaster));
    if ifind<>-1 then
       ComboBox_DisSlave.Items.Delete(ifind);
    If oldmaster = newmaster Then
        Exit;

    For i := 0 To ComboBox_DisSlave.Items.Count-2 do
    begin
        If StrToInt(ComboBox_DisSlave.Items.Strings[i+1]) = oldmaster Then
            Exit
        Else If StrToInt(ComboBox_DisSlave.Items.Strings[i]) > oldmaster Then
        begin
            ifind:=i;
            Break;
        end
        Else If StrToInt(ComboBox_DisSlave.Items.Strings[i+1]) > oldmaster Then
        begin
            ifind := i + 1;
            Break;
        end;
    end;


    ComboBox_disslave.Items.Insert(ifind,IntToStr(oldmaster));

end;

procedure TForm1.FormCreate(Sender: TObject);
var
i: Integer;
begin

    m_baud[0]:=$1c;
    m_baud[1]:=$041c;
    m_baud[2]:=$311c;

    m_newbaud[0]:=$60007;
    m_newbaud[1]:=$160023;
    m_newbaud[2]:=$1c0010;

    m_cfg.iCardType := 5;
    m_cfg.iCardInd := 0;
    m_cfg.iCANInd := 0;
    m_cfg.iMasterCycle := 500;
    m_cfg.wCANBaud := $1C;
    m_cfg.wMasterID := 0;

    m_newcfg.dwCANBaud:= m_newbaud[0];
    m_newcfg.srcport:=5001;
    m_newcfg.canetip:=23435656;
    m_newcfg.desport:=4001;
    m_newcfg.bserver:=0;

    ComboBox_Devtype.ItemIndex := m_cfg.iCardType - 1;
    ComboBox_DevInd.ItemIndex := m_cfg.iCardInd;
    ComboBox_CANInd.ItemIndex := m_cfg.iCANInd;
    ComboBox_Datatype.ItemIndex:=0;

    showcanet(0);



    ComboBox_Baud.Items.Add('500K');
    ComboBox_Baud.Items.Add('100K');
    ComboBox_Baud.Items.Add('10K');
    Selcanbaud();

    for i := 0 to 254 do
      ComboBox_MasterID.Items.Add(IntToStr(i));
    ComboBox_MasterID.ItemIndex := m_cfg.wMasterID;

    Edit_MasterCycle.Text := IntToStr(m_cfg.iMasterCycle);

    For i := 0 To 254 do
        ComboBox_Disslave.Items.Add(IntToStr(i));
    ComboBox_Disslave.ItemIndex := 0;

    Mgr_AddRoute(@m_cfg, @m_hRoute);
    SetBtnStatus();
end;

procedure TForm1.Button_StartClick(Sender: TObject);
var
oldmasterid:Integer;
newmasterid:Integer;
icycle:Integer;
cfg:ROUTECFG;
//srcport:Integer;
//canetport:Integer;
//canetip: array[0..3] of BYTE;
begin
    If Mgr_IsStarted() = 1 Then
    begin
        Timer1.Enabled := FALSE;
        Mgr_StopSys();
        DelAllFromList(Sender);
    end
    Else
    begin
        newmasterid := ComboBox_MasterID.ItemIndex;
        icycle := StrToInt(Edit_MasterCycle.Text);
        m_cfg.wMasterID := newmasterid;
        m_cfg.iMasterCycle := icycle;
        m_cfg.iCardType:=ComboBox_Devtype.ItemIndex+1;
        //if ComboBox_Devtype.ItemIndex=16 then
        //  m_cfg.iCardType:=18; //PEC9920

        Route_GetConfig(m_hRoute, @cfg);
        oldmasterid := cfg.wMasterID;
        cfg.iCardType := m_cfg.iCardType;
        cfg.iCardInd := m_cfg.iCardInd;
        cfg.iCANInd := m_cfg.iCANInd;
        cfg.wCANBaud := m_cfg.wCANBaud;
        cfg.iMasterCycle := (icycle div MASTER_CYCLEUNIT);
        cfg.wMasterID := newmasterid;
        Route_SetConfig (m_hRoute, @cfg);

        GetNewcfg();

	//豸ͺΪCANETʱҪ²
	//If m_cfg.iCardType=VCI_CANETE then
	//begin
	//	srcport:=4001; //ض˿ڣɸʵ޸ģּΪ4001
	//	canetport:=4001; //CANET˿ڣɸʵ޸ģּΪ4001
	//	canetip[3]:=192; //CANETIPַɸʵ޸ģּΪ192.168.0.178
	//	canetip[2]:=168;
	//	canetip[1]:=0;
	//	canetip[0]:=178;
	//	Route_IOCtl(m_hRoute,1,@srcport,4,0,0);
	//	Route_IOCtl(m_hRoute,2,@canetip[0],4,0,0);
	//	Route_IOCtl(m_hRoute,3,@canetport,4,0,0);
	//end;
      PreStart();



        If Mgr_StartSys() <> ICANOK Then
        begin
            ShowMessage('ʧ');
            SetBtnStatus();
            Exit;
        end;
        SetMaster(oldmasterid, newmasterid,Sender);
        SetBtnStatus();
        Timer1.Interval := m_cfg.iMasterCycle;
        Timer1.Enabled := TRUE;
    end;
    If Mgr_IsStarted() = 1 Then
        Button_Start.Caption:='ֹͣ'
    Else
        Button_Start.Caption := '';
    SetBtnStatus

end;
procedure TForm1.PreStart();
begin
    if   (VCI_PCI5010_U= m_cfg.iCardType) or (VCI_USBCAN_E_U= m_cfg.iCardType)  or
           (VCI_USBCAN_2E_U= m_cfg.iCardType)  or (VCI_PCI5020_U= m_cfg.iCardType)
           then
    begin
    Route_IOCtl(m_hRoute,IOCTL_ROUTE_SETBAUD,@m_newcfg.dwCANBaud,4,0,0);
    end
    else if  VCI_CANETE= m_cfg.iCardType then
    begin
        Route_IOCtl(m_hRoute,IOCTL_ROUTE_SETSRCPORT,@m_newcfg.srcport,4,0,0);
        Route_IOCtl(m_hRoute,IOCTL_ROUTE_SETDESIP,@m_newcfg.canetip,4,0,0);
        Route_IOCtl(m_hRoute,IOCTL_ROUTE_SETDESPORT,@m_newcfg.desport,4,0,0);
    end
    else  if  VCI_CANETTCP= m_cfg.iCardType then
    begin
        Route_IOCtl(m_hRoute,IOCTL_ROUTE_SETSRCPORT,@m_newcfg.srcport,4,0,0);
        Route_IOCtl(m_hRoute,IOCTL_ROUTE_SETDESIP,@m_newcfg.canetip,4,0,0);
        Route_IOCtl(m_hRoute,IOCTL_ROUTE_SETDESPORT,@m_newcfg.desport,4,0,0);
        Route_IOCtl(m_hRoute,IOCTL_ROUTE_SETMODE,@m_newcfg.bserver,4,0,0);
    end;

end;

procedure TForm1.Button_ConnectClick(Sender: TObject);
var
isel:Integer;
slaveid:Integer;
hslave:Integer;
ret:Integer;
begin
    isel := ComboBox_DisSlave.ItemIndex;
    slaveid := StrToInt(ComboBox_DisSlave.Items.Strings[isel]);

    ret := Route_AddSlave(m_hRoute, slaveid, @hslave);
    If (ret = ICANOK) or (ret = ICANERR_ITEMEXIST) then
    begin
        Route_GetSlavebyID(m_hRoute, slaveid, @hslave);
        If Slave_Connect(hslave) = ICANOK Then
        begin
            ComboBox_DisSlave.Items.Delete(isel);
            AddConnectedItem (hslave);
        end
        Else
            ShowMessage('Ӵվʧ');
    end
    Else
        ShowMessage('Ӵվʧ');

end;

procedure TForm1.Button_SendDataClick(Sender: TObject);
var
ind:Integer;
id:Integer;
hslave:Integer;
addrarr:array[0..1] of byte;
buf:array[0..31] of byte;
len:Integer;
begin
    ind := ComboBox_ConSlave.ItemIndex;
    If ind =-1 Then
    begin
        ShowMessage('ѡվ');
        Exit;
    end;
    id := StrToInt(ComboBox_ConSlave.Items.Strings[ind]);
    Route_GetSlavebyID(m_hRoute, id, @hslave);
    addrarr[0] := $20;
    addrarr[1] := $60;
    len := 32;

    GetByteArr(Edit_Data,@buf[0],@len);
    
    If len = 0 Then
    begin
        showmessage('뷢');
        Exit;
    end;
        
    If Slave_SendData(hslave, addrarr[ComboBox_Datatype.ItemIndex], @buf[0], len) <> ICANOK Then
        showmessage('ʧ');
        
end;

procedure TForm1.Button_DisconnectClick(Sender: TObject);
var
ind:Integer;
hslave:Integer;
hslave2:Integer;
sz,j:Integer;
begin
    ind := ComboBox_ConSlave.ItemIndex;
    If ind = -1 Then
        Exit;

    Route_GetSlavebyID(m_hRoute, StrToInt(ComboBox_ConSlave.Items.Strings[ind]),@hslave);
    Slave_Disconnect(hslave);
    DelItemFromCombo(ComboBox_ConSlave, Slave_GetID(hslave));
    AddItemToCombo(ComboBox_DisSlave,Slave_GetID(hslave));
    sz := ListView_Data.Items.Count;
    For j := sz-1 downto 0 do
    begin
        hslave2 := Integer(ListView_Data.Items.Item[j].Data);
        If hslave2 = hslave Then
            ListView_Data.Items.Delete(j);
    end;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
i,sz,len,hslave:Integer;
buf:array[0..31] of byte;
DateTime : TDateTime;
strtm:AnsiString;
begin
    sz := ListView_Data.Items.Count;
    len := 32;
    DateTime := Time;  // store the current date and time
    strtm := TimeToStr(DateTime); // convert the time into a string

    For i := 0 To sz-1 do
    begin
        hslave := Integer(ListView_Data.Items.Item[i].Data);
        len := 32;
        If (i Mod 3) = 0 Then
        begin
            If Slave_IsConnected(hslave) = 0 Then
            begin
                DisconnectItem (i);
                Exit;
            end;
        end
        Else If (i Mod 3) = 2 Then
        begin
            Slave_GetAIData(hslave, @buf[0],@len);
            If len > 0 Then
            begin
                ListView_Data.Items.Item[i].SubItems[1] := strtm;
                ListView_Data.Items.Item[i].SubItems[2] := DataToStr(buf, len);
            end;
        end
        Else If (i Mod 3) = 1 Then
        begin
            Slave_GetDIData(hslave, @buf[0], @len);
            If len > 0 Then
            begin
                ListView_Data.Items.Item[i].SubItems[1] := strtm;
                ListView_Data.Items.Item[i].SubItems[2] := DataToStr(buf, len);
            end;
        end;
    end;

end;

procedure TForm1.OnDestory(Sender: TObject);
begin
    If Mgr_IsStarted() = 1 Then
        Button_StartClick(Sender);
end;

procedure TForm1.ComboBox_DevtypeChange(Sender: TObject);
begin
      m_cfg.iCardType   :=ComboBox_Devtype.ItemIndex + 1;
      showcanet(0);
end;

end.
