// ControlIni.cpp: implementation of the CControlIni class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ControlIni.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CControlIni::CControlIni()
{
	m_strName="";
}

CControlIni::~CControlIni()
{
}

int CControlIni::SetIni(char *name)
{
	m_strName.Format("%s",name);

	return 1;
}

int CControlIni::Read(char *appname, char *keyname,
					  int &val,int hex/*1 hex,0 dec*/,int idefault)
{
	val=idefault;
	char szval[256];
	int v;
	int getlen=GetPrivateProfileString(appname,keyname,"",szval,255,(LPCTSTR)m_strName);
	if(getlen==0)
		return 0;
	if(hex)
		sscanf(szval,"%x",&v);
	else
		sscanf(szval,"%d",&v);
	val=v;
	return 1;
}

int CControlIni::Read(char *appname, char *keyname,char *szval,int len,char* szdefault)
{
	int getlen=GetPrivateProfileString(appname,keyname,
		szdefault!=NULL?szdefault:"",szval,len,(LPCTSTR)m_strName);
	if(getlen==0)
		return 0;
	return 1;
	
}

int CControlIni::Write(char *appname, char *keyname, char *szval)
{
	int getlen=WritePrivateProfileString(appname,keyname,szval,(LPCTSTR)m_strName);
	if(getlen==0)
		return 0;
	return 1;
	
}

int CControlIni::Write(char *appname, char *keyname, int val, int hex/*1 hex,0 dec*/)
{
	char szval[256];
	if(hex)
		sprintf(szval,"%x",val);
	else
		sprintf(szval,"%d",val);

	int getlen=WritePrivateProfileString(appname,keyname,szval,(LPCTSTR)m_strName);
	if(getlen==0)
		return 0;
	return 1;
	
}
